ResourceBar = class( Turbine.UI.Control );
function ResourceBar:Constructor(parent, width, height, x, y, boxes, colourtable1, colourtable2, ShowText, boxOffset, borderSize, borderColour, boxBackgroundColour, fullBorder)
    Turbine.UI.Control.Constructor( self )

    self.width = width
    self.height = height

    self:SetSize(self.width + borderSize * 2, self.height + borderSize * 2)
    self:SetZOrder(100)
    self:SetMouseVisible(false)
    self:SetBackColor(borderColour)
    self:SetParent(parent)
    self:SetPosition(x, y)

    self.bar = Turbine.UI.Control()
    self.bar:SetParent(self)
    self.bar:SetPosition(borderSize, borderSize)
    self.bar:SetSize(width, height)
    self.bar:SetMouseVisible(false)

    self.adjustment = fullBorder and 1 or 0

    self.boxes = boxes

    self.BarDictionary = {}
    self.BarBackgroundDictionary = {}

    if colourtable1 and type(colourtable1[1]) == "table" then
        if self.boxes > tablelength(colourtable1) then
            self.colourTable = {}
            for i=1, self.boxes, 1 do
                self.colourTable[i] = colourtable1[1]
            end
        else
            self.colourTable = colourtable1
        end
    else
        self.colourTable = {}
        for i=1, self.boxes, 1 do
            self.colourTable[i] = colourtable1
        end
    end

    if colourtable2 and type(colourtable2[1]) == "table" then
        if self.boxes > tablelength(colourtable2) then
            self.colourTable2 = {}
            for i=1, self.boxes, 1 do
                self.colourTable2[i] = colourtable2[1]
            end
        else
            self.colourTable2 = colourtable2
        end
    else
        self.colourTable2 = {}
        for i=1, self.boxes, 1 do
            self.colourTable2[i] = colourtable2
        end
    end

    local boxWidth = (width) / (boxes)

    for i = 1, self.boxes, 1 do
        if boxBackgroundColour and boxBackgroundColour.A > 0 then
            self.BarBackgroundDictionary[i] = ResourceBox(self.bar, (boxOffset / 2) + (i - 1) * boxWidth, boxWidth - boxOffset, self.height, boxBackgroundColour, boxBackgroundColour, 0)
            self.BarBackgroundDictionary[i]:SetVisible(true)   
        end
        self.BarDictionary[i] = ResourceBox(self.bar, (boxOffset / 2) + (i - 1) * boxWidth, boxWidth - boxOffset, self.height, self.colourTable[i], self.colourTable2[i], self.adjustment)
    end  

    self.textBoxViewWindow = Turbine.UI.Window()
    self.textBoxViewWindow:SetParent(self.bar)
    self.textBoxViewWindow:SetSize(20, 20)
    self.textBoxViewWindow:SetPosition((self.width - 22) / 2 , (height - 23) / 2)
    self.textBoxViewWindow:SetVisible(true)

    self.textBox = Turbine.UI.Label()
    self.textBox:SetParent(self.textBoxViewWindow)
    self.textBox:SetSize(20, 20)
    self.textBox:SetPosition(0, 0)
    self.textBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.textBox:SetOutlineColor( Turbine.UI.Color( 1, 0, 0, 0 ) )
    self.textBox:SetFontStyle( Turbine.UI.FontStyle.Outline )
    self.textBox:SetFont(Turbine.UI.Lotro.Font.TrajanProBold24)
    self.textBox:SetText("0")
    --self.textBox:SetBackColor(Turbine.UI.Color(0, 0, 0))
    self.textBox:SetMouseVisible(false)
    self.textBox:SetVisible(false)
end

function ResourceBar:ChangeResource(NewNumber, Colour1, Colour2)
    --Turbine.UI.Color(1,0.250,0.250)
    self.textBox:SetText(NewNumber)
    self.textBox:SetVisible(NewNumber > 0)
    for i = 1, self.boxes, 1 do
        if i <= NewNumber then
            self.BarDictionary[i]:SetVisible(true)
            if Colour1 and Colour2 then
                self.BarDictionary[i]:TurnOn( Colour1, Colour2)
            end
        else
            self.BarDictionary[i]:SetVisible(false)
        end
    end  
end

function ResourceBar:Unload()
    self:SetVisible(false)
    self:SetParent(nil)
end

ResourceBox = class( Turbine.UI.Control );
function ResourceBox:Constructor(parent, x, width, height, colour, colour2, adjustment)

    Turbine.UI.Control.Constructor( self )
    self:SetParent(parent)
    self:SetBackColor(colour2)
    --self:SetBackground("PrimePlugins/Vitals/Images/FittedSmooth.tga")
    self:SetPosition(x, 0)
    self:SetSize(width, height)
    self:SetMouseVisible(false)
    self:SetVisible(false)

    self.InnerBarBackground = Turbine.UI.Control()
    self.InnerBarBackground:SetParent(self)
    self.InnerBarBackground:SetBackColor(Turbine.UI.Color(0.250,0.250,0.250))
    --self.InnerBarBackground:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
    self.InnerBarBackground:SetPosition(1, 1)
    self.InnerBarBackground:SetSize(width - 1 - adjustment, height - 1 - adjustment)
    self.InnerBarBackground:SetMouseVisible(false)
    self.InnerBarBackground:SetBackColor(colour)

    self.InnerBar = Turbine.UI.Control()
    self.InnerBar:SetParent(self)
    --self.InnerBar:SetBackColor(Turbine.UI.Color(1,0.250,0.250))
    self.InnerBar:SetPosition(1, 1)
    self.InnerBar:SetSize(width - 2, height - 2)
    self.InnerBar:SetMouseVisible(false)

end

function ResourceBox:TurnOn(Colour1, Colour2)
    self:SetBackColor(Colour1)
    self.InnerBarBackground:SetBackColor(Colour2)
end

function ResourceBox:TurnOff()
    self.InnerBar:SetBackColor()
end